/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Contents of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.132 - (show annotations) (download)
Sun May 20 10:32:05 2012 UTC (2 years, 3 months ago) by vapier
Branch: MAIN
Changes since 1.131: +4 -1 lines
eautoreconf: automatically run eautopoint when the code base uses it

1 # Copyright 1999-2012 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.131 2012/05/20 10:26:05 vapier Exp $
4
5 # @ECLASS: autotools.eclass
6 # @MAINTAINER:
7 # base-system@gentoo.org
8 # @BLURB: Regenerates auto* build scripts
9 # @DESCRIPTION:
10 # This eclass is for safely handling autotooled software packages that need to
11 # regenerate their build scripts. All functions will abort in case of errors.
12
13 # Note: We require GNU m4, as does autoconf. So feel free to use any features
14 # from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16 if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17 ___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
18
19 inherit eutils libtool
20
21 # @ECLASS-VARIABLE: WANT_AUTOCONF
22 # @DESCRIPTION:
23 # The major version of autoconf your package needs
24 : ${WANT_AUTOCONF:=latest}
25
26 # @ECLASS-VARIABLE: WANT_AUTOMAKE
27 # @DESCRIPTION:
28 # The major version of automake your package needs
29 : ${WANT_AUTOMAKE:=latest}
30
31 # @ECLASS-VARIABLE: WANT_LIBTOOL
32 # @DESCRIPTION:
33 # Do you want libtool? Valid values here are "latest" and "none".
34 : ${WANT_LIBTOOL:=latest}
35
36 # @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37 # @INTERNAL
38 # @DESCRIPTION:
39 # CONSTANT!
40 # The latest major version/slot of automake available on each arch. #312315
41 # If a newer slot is stable on any arch, and is NOT reflected in this list,
42 # then circular dependencies may arise during emerge @system bootstraps.
43 # Do NOT change this variable in your ebuilds!
44 # If you want to force a newer minor version, you can specify the correct
45 # WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
46 _LATEST_AUTOMAKE=( 1.11.1:1.11 )
47
48 _automake_atom="sys-devel/automake"
49 _autoconf_atom="sys-devel/autoconf"
50 if [[ -n ${WANT_AUTOMAKE} ]]; then
51 case ${WANT_AUTOMAKE} in
52 none) _automake_atom="" ;; # some packages don't require automake at all
53 # if you change the "latest" version here, change also autotools_run_tool
54 # this MUST reflect the latest stable major version for each arch!
55 latest)
56 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
57 if [[ ${EAPI:-0} != 0 ]] ; then
58 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
59 else
60 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
61 fi
62 ;;
63 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
64 esac
65 export WANT_AUTOMAKE
66 fi
67
68 if [[ -n ${WANT_AUTOCONF} ]] ; then
69 case ${WANT_AUTOCONF} in
70 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
71 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
72 # if you change the "latest" version here, change also autotools_env_setup
73 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
74 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
75 esac
76 export WANT_AUTOCONF
77 fi
78
79 _libtool_atom="sys-devel/libtool"
80 if [[ -n ${WANT_LIBTOOL} ]] ; then
81 case ${WANT_LIBTOOL} in
82 none) _libtool_atom="" ;;
83 latest) ;;
84 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
85 esac
86 export WANT_LIBTOOL
87 fi
88
89 AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
90 RDEPEND=""
91
92 # @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
93 # @DESCRIPTION:
94 # Set to 'no' to disable automatically adding to DEPEND. This lets
95 # ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
96 # their own DEPEND string.
97 : ${AUTOTOOLS_AUTO_DEPEND:=yes}
98 if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
99 DEPEND=${AUTOTOOLS_DEPEND}
100 fi
101
102 unset _automake_atom _autoconf_atom
103
104 # @ECLASS-VARIABLE: AM_OPTS
105 # @DEFAULT_UNSET
106 # @DESCRIPTION:
107 # Additional options to pass to automake during
108 # eautoreconf call.
109
110 # @ECLASS-VARIABLE: AT_NOEAUTOMAKE
111 # @DEFAULT_UNSET
112 # @DESCRIPTION:
113 # Don't run eautomake command if set to 'yes'; only used to workaround
114 # broken packages. Generally you should, instead, fix the package to
115 # not call AM_INIT_AUTOMAKE if it doesn't actually use automake.
116
117 # @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
118 # @DEFAULT_UNSET
119 # @DESCRIPTION:
120 # Don't run elibtoolize command if set to 'yes',
121 # useful when elibtoolize needs to be ran with
122 # particular options
123
124 # @ECLASS-VARIABLE: AT_M4DIR
125 # @DESCRIPTION:
126 # Additional director(y|ies) aclocal should search
127 : ${AT_M4DIR:=}
128
129 # @ECLASS-VARIABLE: AT_SYS_M4DIR
130 # @INTERNAL
131 # @DESCRIPTION:
132 # For system integrators, a list of additional aclocal search paths.
133 # This variable gets eval-ed, so you can use variables in the definition
134 # that may not be valid until eautoreconf & friends are run.
135 : ${AT_SYS_M4DIR:=}
136
137 # @FUNCTION: eautoreconf
138 # @DESCRIPTION:
139 # This function mimes the behavior of autoreconf, but uses the different
140 # eauto* functions to run the tools. It doesn't accept parameters, but
141 # the directory with include files can be specified with AT_M4DIR variable.
142 #
143 # Should do a full autoreconf - normally what most people will be interested in.
144 # Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
145 eautoreconf() {
146 local x g
147
148 if [[ -z ${AT_NO_RECURSIVE} ]]; then
149 # Take care of subdirs
150 for x in $(autotools_get_subdirs); do
151 if [[ -d ${x} ]] ; then
152 pushd "${x}" >/dev/null
153 AT_NOELIBTOOLIZE="yes" eautoreconf
154 popd >/dev/null
155 fi
156 done
157 fi
158
159 local auxdir=$(autotools_get_auxdir)
160 local macdir=$(autotools_get_macrodir)
161
162 einfo "Running eautoreconf in '${PWD}' ..."
163 [[ -n ${auxdir}${macdir} ]] && mkdir -p ${auxdir} ${macdir}
164 eaclocal
165 if grep -q '^AM_GNU_GETTEXT_VERSION' configure.?? ; then
166 eautopoint --force
167 fi
168 [[ ${CHOST} == *-darwin* ]] && g=g
169 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
170 _elibtoolize --copy --force --install
171 else
172 _elibtoolize --copy --force
173 fi
174 eautoconf
175 eautoheader
176 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
177
178 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
179
180 # Call it here to prevent failures due to elibtoolize called _before_
181 # eautoreconf. We set $S because elibtoolize runs on that #265319
182 S=${PWD} elibtoolize --force
183
184 return 0
185 }
186
187 # @FUNCTION: eaclocal_amflags
188 # @DESCRIPTION:
189 # Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
190 # (most) of the crazy crap that people throw at us.
191 eaclocal_amflags() {
192 local aclocal_opts amflags_file
193
194 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
195 [[ -e ${amflags_file} ]] || continue
196 # setup the env in case the pkg does something crazy
197 # in their ACLOCAL_AMFLAGS. like run a shell script
198 # which turns around and runs autotools. #365401
199 # or split across multiple lines. #383525
200 autotools_env_setup
201 aclocal_opts=$(sed -n \
202 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
203 # match the first line
204 s:[^=]*=::p; \
205 # then gobble up all escaped lines
206 : nextline /\\\\$/{ n; p; b nextline; } \
207 }" ${amflags_file})
208 eval aclocal_opts=\""${aclocal_opts}"\"
209 break
210 done
211
212 echo ${aclocal_opts}
213 }
214
215 # @FUNCTION: eaclocal
216 # @DESCRIPTION:
217 # These functions runs the autotools using autotools_run_tool with the
218 # specified parametes. The name of the tool run is the same of the function
219 # without e prefix.
220 # They also force installing the support files for safety.
221 # Respects AT_M4DIR for additional directories to search for macro's.
222 eaclocal() {
223 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
224 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
225 }
226
227 # @FUNCTION: _elibtoolize
228 # @DESCRIPTION:
229 # Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
230 # libtool.eclass.
231 _elibtoolize() {
232 local opts g=
233
234 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
235 # check for both it and the current AC_PROG_LIBTOOL)
236 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
237
238 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
239
240 [[ ${CHOST} == *-darwin* ]] && g=g
241 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
242
243 # Need to rerun aclocal
244 eaclocal
245 }
246
247 # @FUNCTION: eautoheader
248 # @DESCRIPTION:
249 # Runs autoheader.
250 eautoheader() {
251 # Check if we should run autoheader
252 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
253 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
254 }
255
256 # @FUNCTION: eautoconf
257 # @DESCRIPTION:
258 # Runs autoconf.
259 eautoconf() {
260 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
261 echo
262 eerror "No configure.{ac,in} present in '${PWD}'!"
263 echo
264 die "No configure.{ac,in} present!"
265 fi
266
267 autotools_run_tool --at-m4flags autoconf "$@"
268 }
269
270 # @FUNCTION: eautomake
271 # @DESCRIPTION:
272 # Runs automake.
273 eautomake() {
274 local extra_opts
275 local makefile_name
276
277 # Run automake if:
278 # - a Makefile.am type file exists
279 # - the configure script is using the AM_INIT_AUTOMAKE directive
280 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
281 [[ -f ${makefile_name} ]] && break
282 done
283
284 if [[ -z ${makefile_name} ]] ; then
285 # Really we should just use autotools_check_macro ...
286 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
287 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
288 return 0
289 fi
290
291 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
292 local used_automake
293 local installed_automake
294
295 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
296 sed -e 's:.*(GNU automake) ::')
297 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
298 sed -e 's:.*by automake \(.*\) from .*:\1:')
299
300 if [[ ${installed_automake} != ${used_automake} ]]; then
301 einfo "Automake used for the package (${used_automake}) differs from"
302 einfo "the installed version (${installed_automake})."
303 eautoreconf
304 return 0
305 fi
306 fi
307
308 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
309 || extra_opts="${extra_opts} --foreign"
310
311 # --force-missing seems not to be recognized by some flavours of automake
312 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
313 }
314
315 # @FUNCTION: eautopoint
316 # @DESCRIPTION:
317 # Runs autopoint (from the gettext package).
318 eautopoint() {
319 autotools_run_tool autopoint "$@"
320 }
321
322 # @FUNCTION: config_rpath_update
323 # @USAGE: [destination]
324 # @DESCRIPTION:
325 # Some packages utilize the config.rpath helper script, but don't
326 # use gettext directly. So we have to copy it in manually since
327 # we can't let `autopoint` do it for us.
328 config_rpath_update() {
329 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
330
331 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
332 [[ $# -eq 0 ]] && return 0
333
334 einfo "Updating all config.rpath files"
335 for dst in "$@" ; do
336 einfo " ${dst}"
337 cp "${src}" "${dst}" || die
338 done
339 }
340
341 # Internal function to run an autotools' tool
342 autotools_env_setup() {
343 # We do the "latest" → version switch here because it solves
344 # possible order problems, see bug #270010 as an example.
345 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
346 local pv
347 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
348 # has_version respects ROOT, but in this case, we don't want it to,
349 # thus "ROOT=/" prefix:
350 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
351 done
352 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
353 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
354 fi
355 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
356 }
357 autotools_run_tool() {
358 # Process our own internal flags first
359 local autofail=true m4flags=false
360 while [[ -n $1 ]] ; do
361 case $1 in
362 --at-no-fail) autofail=false;;
363 --at-m4flags) m4flags=true;;
364 # whatever is left goes to the actual tool
365 *) break;;
366 esac
367 shift
368 done
369
370 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
371 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
372 fi
373
374 autotools_env_setup
375
376 local STDERR_TARGET="${T}/$1.out"
377 # most of the time, there will only be one run, but if there are
378 # more, make sure we get unique log filenames
379 if [[ -e ${STDERR_TARGET} ]] ; then
380 local i=1
381 while :; do
382 STDERR_TARGET="${T}/$1-${i}.out"
383 [[ -e ${STDERR_TARGET} ]] || break
384 : $(( i++ ))
385 done
386 fi
387
388 if ${m4flags} ; then
389 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
390 fi
391
392 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
393
394 ebegin "Running $@"
395 "$@" >> "${STDERR_TARGET}" 2>&1
396 if ! eend $? && ${autofail} ; then
397 echo
398 eerror "Failed Running $1 !"
399 eerror
400 eerror "Include in your bugreport the contents of:"
401 eerror
402 eerror " ${STDERR_TARGET}"
403 echo
404 die "Failed Running $1 !"
405 fi
406 }
407
408 # Internal function to check for support
409 autotools_check_macro() {
410 [[ -f configure.ac || -f configure.in ]] || return 0
411 local macro
412 for macro ; do
413 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
414 done
415 return 0
416 }
417
418 # Internal function to look for a macro and extract its value
419 autotools_check_macro_val() {
420 local macro=$1 scan_out
421
422 autotools_check_macro "${macro}" | \
423 gawk -v macro="${macro}" \
424 '($0 !~ /^[[:space:]]*(#|dnl)/) {
425 if (match($0, macro ":(.*)$", res))
426 print res[1]
427 }' | uniq
428
429 return 0
430 }
431
432 # Internal function to get additional subdirs to configure
433 autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
434 autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
435 autotools_get_macrodir() { autotools_check_macro_val AC_CONFIG_MACRO_DIR ; }
436
437 _autotools_m4dir_include() {
438 local x include_opts
439
440 for x in "$@" ; do
441 case ${x} in
442 # We handle it below
443 -I) ;;
444 *)
445 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
446 include_opts+=" -I ${x}"
447 ;;
448 esac
449 done
450
451 echo ${include_opts}
452 }
453 autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
454 autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
455
456 fi

  ViewVC Help
Powered by ViewVC 1.1.20